tpl_toc = '<article id="toc"><h3>Contents</h3><ul style="margin:0em; padding:0em; list-style:none;">\n{{#entry}}    <li><a href="#{{escaped}}">{{&unescaped}}</a></li>\n{{/entry}}</ul></article>\n\n'

$(document).ready(function() {
    var arr = [];
    $('article h2').each(function(index) {
        // uses the browser's innerHTML property
        // http://api.jquery.com/html/
        var _id = $(this).html()
        var attrs = {};

        attrs.unescaped = _id;

        // "certain special" characters will not work as a link target, so
        // replace "special characters" with '_'
        // would like a more generic way to do this
        //chars_replaced = _id;
        //chars_replaced = chars_replaced.replace(/ /g, "_");
        //chars_replaced = chars_replaced.replace(/[[]/g, "_");
        //chars_replaced = chars_replaced.replace(/[\]]/g, "_");
        //attrs.escaped = encodeURI(chars_replaced);

        // better than above, just keep characters that must be valid
        attrs.escaped = _id.replace(/[^a-zA-Z0-9-_]/g, '');

        arr.push(attrs);

        $(this).attr("id", attrs.escaped)
    });

    obj = { "entry" : arr };

    // TODO: probably should replace some existing div element, thereby allowing the toc
    // location to be specified on the .html page
    insertObj = $('article h2').eq(0);

    insertObj
        .before(
            Mustache.render(
                tpl_toc,
                obj
            )
        );

    $.map( $('article h2'),
        function (element) {
            $(element).before('<hr>');
        }
    )

    /*-------------------------------------------------------------------- 
     * jQuery pixel/em conversion plugins: toEm() and toPx()
     * by Scott Jehl (scott@filamentgroup.com), http://www.filamentgroup.com
     * Copyright (c) Filament Group
     * Dual licensed under the MIT (filamentgroup.com/examples/mit-license.txt) or GPL (filamentgroup.com/examples/gpl-license.txt) licenses.
     * Article: http://www.filamentgroup.com/lab/update_jquery_plugin_for_retaining_scalable_interfaces_with_pixel_to_em_con/
     * Options:
            scope: string or jQuery selector for font-size scoping
     * Usage Example: $(myPixelValue).toEm(); or $(myEmValue).toPx();
    --------------------------------------------------------------------*/
    $.fn.toEm = function(settings){
        settings = jQuery.extend({
            scope: 'body'
        }, settings);
        var that = parseInt(this[0],10),
            scopeTest = jQuery('<div style="display: none; font-size: 1em; margin: 0; padding:0; height: auto; line-height: 1; border:0;">&nbsp;</div>').appendTo(settings.scope),
            scopeVal = scopeTest.height();
        scopeTest.remove();
        return (that / scopeVal).toFixed(8);
    };

    // set the width of the toc#article to be slightly bigger than the text
    // Using a span does not always work perfectly to prevent wrapping, so loop on trying a little larger
    $('article#toc').each(function(index) {
        var start_height = $('article#toc').height()
        var original_html = $(this).html();

        $(this).html('<span style="display: inline-block;">' + original_html + '</span>');
        var width = $(this).find('span:first').width();
        var em_width = width / parseFloat($(this).css("font-size"));
        em_width = $(width).toEm();
        $(this).html(original_html);
        $(this).width(em_width.toString() + 'em');

        //console.log(width);
        //console.log(em_width);
        //console.log($(this).css("width"));

        // occasionally the text will still wrap, try to increase the width just a little more to correct this
        if (start_height < $('article#toc').height()) {
            for (i=1; i<=10; ++i) {
                em_width += i/10;
                $(this).width(em_width.toString() + 'em');
                if (start_height >= $('article#toc').height()) break;
            }
        }

        // occasionally the text will be too large, decrease a small amount
        for (i=1; i<=20; ++i) {
            prev_width = em_width;
            em_width -= i/10;
            $(this).width(em_width.toString() + 'em');
            if (start_height < $('article#toc').height()) {
                $(this).width(prev_width.toString() + 'em');
                break;
            }
        }

        return em_width
    });
});
